/*
  Copyright 1993-2009 Medical Image Processing Group
              Department of Radiology
            University of Pennsylvania

This file is part of CAVASS.

CAVASS is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

CAVASS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with CAVASS.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef _GradientImageComputation_H_
#define _GradientImageComputation_H_

//#include <string>
#include <math.h>
#include "cv3dv.h"

class GradientImageComputation {
private:
  unsigned short   *m_InData;
  unsigned short   *m_GradientData;
  
  ViewnixHeader    *m_vh;


public:
  GradientImageComputation();                   // Constructor   
  ~GradientImageComputation();                  // Deconstructor
  
  void SetInputImage(unsigned short *data)
  {
    m_InData = data;
  }
  void SetViewnixHeader(ViewnixHeader* vh)
  {
    m_vh = vh;
  }

  unsigned short* GetGradientImage()
  {
    if(m_GradientData)
      return m_GradientData;
  }

  void  Execute();

private:
  void  ComputeGradientImage();

};
#include "GradientImageComputation.cxx"

#endif
